'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.onPropChange = exports.addSpecs = exports.createClass = exports.combine = exports.componentWillUnmount = exports.componentDidUpdate = exports.componentWillUpdate = exports.shouldComponentUpdate = exports.componentWillReceiveProps = exports.componentDidMount = exports.componentWillMount = exports.displayName = exports.statics = exports.mixins = exports.propTypes = exports.getDefaultProps = exports.getInitialState = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var merge = function merge() {
    for (var _len = arguments.length, objs = Array(_len), _key = 0; _key < _len; _key++) {
        objs[_key] = arguments[_key];
    }

    return Object.assign.apply(Object, [{}].concat(_toConsumableArray(Object.keys(objs).filter(function (key) {
        return objs[key] && objs[key].constructor === Object;
    }).map(function (key) {
        return objs[key];
    }))));
},
    keyMirror = function keyMirror(str) {
    return merge.apply(undefined, _toConsumableArray(str.split(' ').map(function (it) {
        return _defineProperty({}, it, it);
    })));
},
    compose = function compose() {
    for (var _len2 = arguments.length, funcs = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        funcs[_key2] = arguments[_key2];
    }

    return function () {
        for (var _len3 = arguments.length, defaultArgs = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
            defaultArgs[_key3] = arguments[_key3];
        }

        return funcs.concat().reverse().reduce(function () {
            var args = arguments.length <= 0 || arguments[0] === undefined ? [] : arguments[0];
            var func = arguments[1];
            return [func.apply(undefined, _toConsumableArray(args))];
        }, defaultArgs)[0];
    };
},
    pick = function pick(hash) {
    var data = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];
    return Object.assign.apply(Object, [{}].concat(_toConsumableArray(Object.keys(data).filter(function (key) {
        return hash[key];
    }).map(function (key) {
        return _defineProperty({}, key, data[key]);
    }))));
},
    specs = keyMirror('getInitialState getDefaultProps propTypes mixins statics displayName'),
    lifecycles = keyMirror('componentWillMount componentDidMount componentWillReceiveProps shouldComponentUpdate componentWillUpdate componentDidUpdate componentWillUnmount'),
    helpers = keyMirror('receivedProps'),
    formatComponentData = function formatComponentData(data) {
    return [pick(specs, data), pick(lifecycles, data), pick(helpers, data)];
},
    asInternal = function asInternal(f) {
    f.__functionalReact = true;

    return f;
},
    isInternal = function isInternal(f) {
    return f && f.__functionalReact;
},
    mergeComponentSpecs = function mergeComponentSpecs(methods) {
    var newMethods = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];
    return merge.apply(undefined, [methods].concat(_toConsumableArray(Object.keys(newMethods).map(function (key) {
        return _defineProperty({}, key, methods[key] ? methods[key].concat(newMethods[key]) : newMethods[key]);
    }))));
},
    accumulateComponent = function accumulateComponent() {
    var componentMethods = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];
    var componentF = arguments[1];

    if (!componentF) {
        return asInternal(function (componentF, newComponentMethods) {
            return accumulateComponent(mergeComponentSpecs(componentMethods, newComponentMethods), componentF);
        });
    }

    return isInternal(componentF) ? asInternal(function (newComponentF, newComponentMethods) {
        return componentF(newComponentF, mergeComponentSpecs(componentMethods, newComponentMethods));
    }) : makeComponent.apply(undefined, _toConsumableArray(formatComponentData(componentMethods)).concat([componentF]));
},
    callComponentMethods = function callComponentMethods() {
    for (var _len4 = arguments.length, args = Array(_len4 > 2 ? _len4 - 2 : 0), _key4 = 2; _key4 < _len4; _key4++) {
        args[_key4 - 2] = arguments[_key4];
    }

    var funcs = arguments.length <= 0 || arguments[0] === undefined ? [] : arguments[0];
    var self = arguments[1];

    var funcsData = funcs.map(function (func) {
        return func.apply(undefined, [self].concat(args));
    });

    return funcsData;
},
    makeComponent = function makeComponent(specs, lifecycles, helpers, component) {
    var _Array$prototype;

    var displayName = specs.displayName;
    var _getInitialState = specs.getInitialState;
    var _getDefaultProps = specs.getDefaultProps;
    var propTypes = specs.propTypes;
    var mixins = specs.mixins;

    var statics = specs.statics;
    var _lifecycles$component = lifecycles.componentWillReceiveProps;
    var _componentWillReceiveProps = _lifecycles$component === undefined ? [] : _lifecycles$component;
    var _helpers$receivedProp = helpers.receivedProps;
    var receivedProps = _helpers$receivedProp === undefined ? [] : _helpers$receivedProp;


    return _react2.default.createClass({
        displayName: displayName ? displayName.join('.') : 'ReactFunctionalComponent',

        getInitialState: function getInitialState() {
            return _getInitialState ? merge.apply(undefined, _toConsumableArray(callComponentMethods(_getInitialState))) : null;
        },
        getDefaultProps: function getDefaultProps() {
            return _getDefaultProps ? merge.apply(undefined, _toConsumableArray(callComponentMethods(_getDefaultProps))) : null;
        },


        propTypes: propTypes && merge.apply(undefined, _toConsumableArray(propTypes)),

        mixins: mixins && (_Array$prototype = Array.prototype).concat.apply(_Array$prototype, _toConsumableArray(mixins)),

        statics: statics && merge.apply(undefined, _toConsumableArray(specs.statics)),

        componentWillMount: function componentWillMount() {
            var _this = this;

            this.__call = function (funcs) {
                for (var _len5 = arguments.length, args = Array(_len5 > 1 ? _len5 - 1 : 0), _key5 = 1; _key5 < _len5; _key5++) {
                    args[_key5 - 1] = arguments[_key5];
                }

                return funcs && callComponentMethods.apply(undefined, [funcs, _this].concat(args, [_this.props, _this.state]));
            };
            this.__call(lifecycles.componentWillMount);
        },
        componentDidMount: function componentDidMount() {
            this.__call(lifecycles.componentDidMount);
        },
        componentWillReceiveProps: function componentWillReceiveProps(nextProps) {
            var _Array$prototype2,
                _this2 = this;

            var receivedPropsFuncs = (_Array$prototype2 = Array.prototype).concat.apply(_Array$prototype2, _toConsumableArray(receivedProps.map(function (props) {
                return Object.keys(props).filter(function (propName) {
                    return _this2.props[propName] !== nextProps[propName];
                }).map(function (propName) {
                    return props[propName];
                });
            }).concat(_componentWillReceiveProps)));

            this.__call(receivedPropsFuncs, nextProps);
        },
        shouldComponentUpdate: function shouldComponentUpdate(nextProps, nextState) {
            var shouldComponentUpdate = lifecycles.shouldComponentUpdate;


            return shouldComponentUpdate ? this.__call(shouldComponentUpdate, nextProps, nextState).filter(Boolean).length : true;
        },
        componentWillUpdate: function componentWillUpdate(nextProps, nextState) {
            this.__call(lifecycles.componentWillUpdate, nextProps, nextState);
        },
        componentDidUpdate: function componentDidUpdate(prevProps, prevState) {
            this.__call(lifecycles.componentDidUpdate, prevProps, prevState);
        },
        componentWillUnmount: function componentWillUnmount() {
            this.__call(lifecycles.componentWillUnmount);
        },
        render: function render() {
            return _react2.default.createElement(component, _extends({}, this.props, this.state));
        }
    });
},
    specsToArrays = function specsToArrays(specs) {
    return merge.apply(undefined, _toConsumableArray(Object.keys(specs).map(function (key) {
        return _defineProperty({}, key, [specs[key]]);
    })));
},
    makeLiftedFunction = function makeLiftedFunction(name) {
    return function (componentMethod, f) {
        return accumulateComponent(_defineProperty({}, name, [componentMethod]), f);
    };
};

/**
 * Specs
 */
var getInitialState = exports.getInitialState = makeLiftedFunction('getInitialState');
var getDefaultProps = exports.getDefaultProps = makeLiftedFunction('getDefaultProps');
var propTypes = exports.propTypes = makeLiftedFunction('propTypes');
var mixins = exports.mixins = makeLiftedFunction('mixins');
var statics = exports.statics = makeLiftedFunction('statics');
var displayName = exports.displayName = makeLiftedFunction('displayName');

/**
 * Lifecycle methods
 */
var componentWillMount = exports.componentWillMount = makeLiftedFunction('componentWillMount');
var componentDidMount = exports.componentDidMount = makeLiftedFunction('componentDidMount');
var componentWillReceiveProps = exports.componentWillReceiveProps = makeLiftedFunction('componentWillReceiveProps');
var shouldComponentUpdate = exports.shouldComponentUpdate = makeLiftedFunction('shouldComponentUpdate');
var componentWillUpdate = exports.componentWillUpdate = makeLiftedFunction('componentWillUpdate');
var componentDidUpdate = exports.componentDidUpdate = makeLiftedFunction('componentDidUpdate');
var componentWillUnmount = exports.componentWillUnmount = makeLiftedFunction('componentWillUnmount');

/**
 * Helpers
 */
var combine = exports.combine = function combine() {
    return compose.apply(undefined, arguments)();
};

var createClass = exports.createClass = function createClass(specs, f) {
    return accumulateComponent(specsToArrays(specs), f);
};
var addSpecs = exports.addSpecs = function addSpecs(specs, f) {
    console.warn('addSpecs has been renamed to createClass and will be removed in the next major version.');
    return createClass(specs, f);
};

var onPropChange = exports.onPropChange = function onPropChange(receivedProps, f) {
    console.warn('onPropChange has been deprecated and will be removed in the next major version.');
    return accumulateComponent(specsToArrays({ receivedProps: receivedProps }), f);
};
